/* InputMethod.c generated by valac 0.55.3, the Vala compiler
 * generated from InputMethod.vala, do not modify */

/*
* 2019-2020 elementary, Inc. (https://elementary.io)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "keyboard.h"
#include <ibus.h>
#include <gio/gio.h>
#include <glib.h>
#include <granite.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gstdio.h>
#include <glib/gi18n-lib.h>

#define PANTHEON_KEYBOARD_TYPE_SOURCE_SETTINGS (pantheon_keyboard_source_settings_get_type ())
#define PANTHEON_KEYBOARD_SOURCE_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PANTHEON_KEYBOARD_TYPE_SOURCE_SETTINGS, PantheonKeyboardSourceSettings))
#define PANTHEON_KEYBOARD_SOURCE_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PANTHEON_KEYBOARD_TYPE_SOURCE_SETTINGS, PantheonKeyboardSourceSettingsClass))
#define PANTHEON_KEYBOARD_IS_SOURCE_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PANTHEON_KEYBOARD_TYPE_SOURCE_SETTINGS))
#define PANTHEON_KEYBOARD_IS_SOURCE_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PANTHEON_KEYBOARD_TYPE_SOURCE_SETTINGS))
#define PANTHEON_KEYBOARD_SOURCE_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PANTHEON_KEYBOARD_TYPE_SOURCE_SETTINGS, PantheonKeyboardSourceSettingsClass))

typedef struct _PantheonKeyboardSourceSettings PantheonKeyboardSourceSettings;
typedef struct _PantheonKeyboardSourceSettingsClass PantheonKeyboardSourceSettingsClass;
enum  {
	PANTHEON_KEYBOARD_INPUT_METHOD_PAGE_PAGE_0_PROPERTY,
	PANTHEON_KEYBOARD_INPUT_METHOD_PAGE_PAGE_NUM_PROPERTIES
};
static GParamSpec* pantheon_keyboard_input_method_page_page_properties[PANTHEON_KEYBOARD_INPUT_METHOD_PAGE_PAGE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
typedef struct _Block12Data Block12Data;
typedef struct _Block13Data Block13Data;
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PantheonKeyboardInputMethodPagePagePrivate {
	IBusBus* bus;
	GSettings* ibus_panel_settings;
	gboolean selection_changing;
	GList* engines;
	GraniteWidgetsAlertView* spawn_failed_alert;
	GtkListBox* listbox;
	PantheonKeyboardSourceSettings* settings;
	GtkMenuButton* remove_button;
	PantheonKeyboardInputMethodPageAddEnginesPopover* add_engines_popover;
	GtkStack* stack;
	GtkEntry* entry_test;
};

struct _Block12Data {
	int _ref_count_;
	PantheonKeyboardInputMethodPagePage* self;
	gchar* engine_name;
};

struct _Block13Data {
	int _ref_count_;
	PantheonKeyboardInputMethodPagePage* self;
	GtkComboBoxText* keyboard_shortcut_combobox;
};

static gint PantheonKeyboardInputMethodPagePage_private_offset;
static gpointer pantheon_keyboard_input_method_page_page_parent_class = NULL;

VALA_EXTERN GType pantheon_keyboard_source_settings_get_type (void) G_GNUC_CONST ;
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static gchar* pantheon_keyboard_input_method_page_page_get_keyboard_shortcut (PantheonKeyboardInputMethodPagePage* self);
static void pantheon_keyboard_input_method_page_page_set_keyboard_shortcut (PantheonKeyboardInputMethodPagePage* self,
                                                                     const gchar* combobox_id);
static void _vala_array_add3 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add4 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add5 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void pantheon_keyboard_input_method_page_page_update_engines_list (PantheonKeyboardInputMethodPagePage* self);
static void __lambda57_ (PantheonKeyboardInputMethodPagePage* self,
                  GtkWidget* listbox_child);
static void ___lambda57__gtk_callback (GtkWidget* widget,
                                gpointer self);
VALA_EXTERN void pantheon_keyboard_source_settings_reset (PantheonKeyboardSourceSettings* self,
                                              PantheonKeyboardLayoutType* layout_type,
                                              gboolean signal_changed);
VALA_EXTERN gchar** pantheon_keyboard_source_settings_get_active_engines (PantheonKeyboardSourceSettings* self,
                                                              gint* result_length1);
static gchar* pantheon_keyboard_input_method_page_page_gettext_engine_longname (PantheonKeyboardInputMethodPagePage* self,
                                                                         IBusEngineDesc* engine);
VALA_EXTERN gboolean pantheon_keyboard_source_settings_add_layout (PantheonKeyboardSourceSettings* self,
                                                       PantheonKeyboardInputSource* new_layout);
static void pantheon_keyboard_input_method_page_page_write_ibus_autostart_file (PantheonKeyboardInputMethodPagePage* self,
                                                                         gboolean enable);
static void pantheon_keyboard_input_method_page_page_spawn_ibus_daemon (PantheonKeyboardInputMethodPagePage* self);
static void pantheon_keyboard_input_method_page_page_set_visible_view (PantheonKeyboardInputMethodPagePage* self,
                                                                const gchar* error_message);
static gboolean __lambda58_ (PantheonKeyboardInputMethodPagePage* self);
static gboolean ___lambda58__gsource_func (gpointer self);
static gchar** _vala_array_dup4 (gchar** self,
                          gssize length);
static void pantheon_keyboard_input_method_page_page_update_entry_test_usable (PantheonKeyboardInputMethodPagePage* self);
VALA_EXTERN PantheonKeyboardInputSource* pantheon_keyboard_source_settings_get_active_input_source (PantheonKeyboardSourceSettings* self);
static void pantheon_keyboard_input_method_page_page_update_list_box_selected_row (PantheonKeyboardInputMethodPagePage* self);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
static void __lambda59_ (Block12Data* _data12_,
                  GtkWidget* widget);
static void ___lambda59__gtk_callback (GtkWidget* widget,
                                gpointer self);
static GObject * pantheon_keyboard_input_method_page_page_constructor (GType type,
                                                                guint n_construct_properties,
                                                                GObjectConstructParam * construct_properties);
static Block13Data* block13_data_ref (Block13Data* _data13_);
static void block13_data_unref (void * _userdata_);
VALA_EXTERN PantheonKeyboardSourceSettings* pantheon_keyboard_source_settings_get_instance (void);
static void _pantheon_keyboard_input_method_page_page___lambda60_ (PantheonKeyboardInputMethodPagePage* self);
static void __pantheon_keyboard_input_method_page_page___lambda60__granite_widgets_alert_view_action_activated (GraniteWidgetsAlertView* _sender,
                                                                                                         gpointer self);
static void _pantheon_keyboard_input_method_page_page___lambda61_ (PantheonKeyboardInputMethodPagePage* self,
                                                            GtkListBoxRow* row);
VALA_EXTERN void pantheon_keyboard_source_settings_set_active_engine_name (PantheonKeyboardSourceSettings* self,
                                                               const gchar* engine_name);
static void __pantheon_keyboard_input_method_page_page___lambda61__gtk_list_box_row_selected (GtkListBox* _sender,
                                                                                       GtkListBoxRow* row,
                                                                                       gpointer self);
static void _pantheon_keyboard_input_method_page_page___lambda62_ (PantheonKeyboardInputMethodPagePage* self,
                                                            const gchar* name);
static void __pantheon_keyboard_input_method_page_page___lambda62__ibus_bus_global_engine_changed (IBusBus* _sender,
                                                                                            const gchar* name,
                                                                                            gpointer self);
static void _pantheon_keyboard_input_method_page_page___lambda63_ (PantheonKeyboardInputMethodPagePage* self);
static void __pantheon_keyboard_input_method_page_page___lambda63__gtk_button_clicked (GtkButton* _sender,
                                                                                gpointer self);
static void _pantheon_keyboard_input_method_page_page___lambda64_ (PantheonKeyboardInputMethodPagePage* self,
                                                            const gchar* engine);
VALA_EXTERN gboolean pantheon_keyboard_source_settings_add_active_engine (PantheonKeyboardSourceSettings* self,
                                                              const gchar* engine_name);
static void __pantheon_keyboard_input_method_page_page___lambda64__pantheon_keyboard_input_method_page_add_engines_popover_add_engine (PantheonKeyboardInputMethodPageAddEnginesPopover* _sender,
                                                                                                                                const gchar* new_engine,
                                                                                                                                gpointer self);
static void _pantheon_keyboard_input_method_page_page___lambda65_ (PantheonKeyboardInputMethodPagePage* self);
static void _g_free0_ (gpointer var);
static void _vala_gchar_free_function_content_of (gpointer data);
static void _vala_array_add6 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN void pantheon_keyboard_source_settings_set_active_engines (PantheonKeyboardSourceSettings* self,
                                                           gchar** value,
                                                           gint value_length1);
VALA_EXTERN void pantheon_keyboard_source_settings_set_active_index (PantheonKeyboardSourceSettings* self,
                                                         guint value);
static void __pantheon_keyboard_input_method_page_page___lambda65__gtk_button_clicked (GtkButton* _sender,
                                                                                gpointer self);
static void _pantheon_keyboard_input_method_page_page___lambda66_ (Block13Data* _data13_);
static void __pantheon_keyboard_input_method_page_page___lambda66__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                                   gpointer self);
static void _pantheon_keyboard_input_method_page_page___lambda67_ (PantheonKeyboardInputMethodPagePage* self);
static void __pantheon_keyboard_input_method_page_page___lambda67__g_object_notify (GObject* _sender,
                                                                             GParamSpec* pspec,
                                                                             gpointer self);
static void pantheon_keyboard_input_method_page_page_finalize (GObject * obj);
static GType pantheon_keyboard_input_method_page_page_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
pantheon_keyboard_input_method_page_page_get_instance_private (PantheonKeyboardInputMethodPagePage* self)
{
	return G_STRUCT_MEMBER_P (self, PantheonKeyboardInputMethodPagePage_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static gchar*
pantheon_keyboard_input_method_page_page_get_keyboard_shortcut (PantheonKeyboardInputMethodPagePage* self)
{
	gchar** keyboard_shortcuts = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gint keyboard_shortcuts_length1;
	gint _keyboard_shortcuts_size_;
	gchar* keyboard_shortcut = NULL;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = pantheon_keyboard_plug_ibus_general_settings;
	_tmp1_ = g_settings_get_child (_tmp0_, "hotkey");
	_tmp2_ = _tmp1_;
	_tmp4_ = _tmp3_ = g_settings_get_strv (_tmp2_, "triggers");
	_tmp5_ = _tmp4_;
	_tmp5__length1 = _vala_array_length (_tmp3_);
	_g_object_unref0 (_tmp2_);
	keyboard_shortcuts = _tmp5_;
	keyboard_shortcuts_length1 = _tmp5__length1;
	_keyboard_shortcuts_size_ = keyboard_shortcuts_length1;
	_tmp6_ = g_strdup ("");
	keyboard_shortcut = _tmp6_;
	_tmp7_ = keyboard_shortcuts;
	_tmp7__length1 = keyboard_shortcuts_length1;
	{
		gchar** ks_collection = NULL;
		gint ks_collection_length1 = 0;
		gint _ks_collection_size_ = 0;
		gint ks_it = 0;
		ks_collection = _tmp7_;
		ks_collection_length1 = _tmp7__length1;
		for (ks_it = 0; ks_it < ks_collection_length1; ks_it = ks_it + 1) {
			gchar* _tmp8_;
			gchar* ks = NULL;
			_tmp8_ = g_strdup (ks_collection[ks_it]);
			ks = _tmp8_;
			{
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				GQuark _tmp12_ = 0U;
				static GQuark _tmp11_label0 = 0;
				static GQuark _tmp11_label1 = 0;
				static GQuark _tmp11_label2 = 0;
				_tmp9_ = ks;
				_tmp10_ = _tmp9_;
				_tmp12_ = (NULL == _tmp10_) ? 0 : g_quark_from_string (_tmp10_);
				if (_tmp12_ == ((0 != _tmp11_label0) ? _tmp11_label0 : (_tmp11_label0 = g_quark_from_static_string ("<Alt>space")))) {
					switch (0) {
						default:
						{
							gchar* _tmp13_;
							_tmp13_ = g_strdup ("alt-space");
							_g_free0 (keyboard_shortcut);
							keyboard_shortcut = _tmp13_;
							break;
						}
					}
				} else if (_tmp12_ == ((0 != _tmp11_label1) ? _tmp11_label1 : (_tmp11_label1 = g_quark_from_static_string ("<Shift>space")))) {
					switch (0) {
						default:
						{
							gchar* _tmp14_;
							_tmp14_ = g_strdup ("shift-space");
							_g_free0 (keyboard_shortcut);
							keyboard_shortcut = _tmp14_;
							break;
						}
					}
				} else if (_tmp12_ == ((0 != _tmp11_label2) ? _tmp11_label2 : (_tmp11_label2 = g_quark_from_static_string ("<Control>space")))) {
					switch (0) {
						default:
						{
							gchar* _tmp15_;
							_tmp15_ = g_strdup ("ctl-space");
							_g_free0 (keyboard_shortcut);
							keyboard_shortcut = _tmp15_;
							break;
						}
					}
				} else {
					switch (0) {
						default:
						{
							break;
						}
					}
				}
				_g_free0 (ks);
			}
		}
	}
	result = keyboard_shortcut;
	keyboard_shortcuts = (_vala_array_free (keyboard_shortcuts, keyboard_shortcuts_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

static void
_vala_array_add3 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add4 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add5 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
pantheon_keyboard_input_method_page_page_set_keyboard_shortcut (PantheonKeyboardInputMethodPagePage* self,
                                                                const gchar* combobox_id)
{
	gchar** keyboard_shortcuts = NULL;
	gchar** _tmp0_;
	gint keyboard_shortcuts_length1;
	gint _keyboard_shortcuts_size_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
	static GQuark _tmp2_label0 = 0;
	static GQuark _tmp2_label1 = 0;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	g_return_if_fail (self != NULL);
	g_return_if_fail (combobox_id != NULL);
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	keyboard_shortcuts = _tmp0_;
	keyboard_shortcuts_length1 = 0;
	_keyboard_shortcuts_size_ = keyboard_shortcuts_length1;
	_tmp1_ = combobox_id;
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("alt-space")))) {
		switch (0) {
			default:
			{
				gchar* _tmp4_;
				_tmp4_ = g_strdup ("<Alt>space");
				_vala_array_add3 (&keyboard_shortcuts, &keyboard_shortcuts_length1, &_keyboard_shortcuts_size_, _tmp4_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("shift-space")))) {
		switch (0) {
			default:
			{
				gchar* _tmp5_;
				_tmp5_ = g_strdup ("<Shift>space");
				_vala_array_add4 (&keyboard_shortcuts, &keyboard_shortcuts_length1, &_keyboard_shortcuts_size_, _tmp5_);
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				gchar* _tmp6_;
				_tmp6_ = g_strdup ("<Control>space");
				_vala_array_add5 (&keyboard_shortcuts, &keyboard_shortcuts_length1, &_keyboard_shortcuts_size_, _tmp6_);
				break;
			}
		}
	}
	_tmp7_ = pantheon_keyboard_plug_ibus_general_settings;
	_tmp8_ = g_settings_get_child (_tmp7_, "hotkey");
	_tmp9_ = _tmp8_;
	_tmp10_ = keyboard_shortcuts;
	_tmp10__length1 = keyboard_shortcuts_length1;
	g_settings_set_strv (_tmp9_, "triggers", _tmp10_);
	_g_object_unref0 (_tmp9_);
	keyboard_shortcuts = (_vala_array_free (keyboard_shortcuts, keyboard_shortcuts_length1, (GDestroyNotify) g_free), NULL);
}

static void
__lambda57_ (PantheonKeyboardInputMethodPagePage* self,
             GtkWidget* listbox_child)
{
	g_return_if_fail (listbox_child != NULL);
	gtk_widget_destroy (listbox_child);
}

static void
___lambda57__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
	__lambda57_ ((PantheonKeyboardInputMethodPagePage*) self, widget);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
pantheon_keyboard_input_method_page_page_update_engines_list (PantheonKeyboardInputMethodPagePage* self)
{
	IBusBus* _tmp0_;
	GList* _tmp1_;
	GtkListBox* _tmp2_;
	PantheonKeyboardSourceSettings* _tmp3_;
	PantheonKeyboardLayoutType _tmp4_;
	PantheonKeyboardSourceSettings* _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gint _tmp7_ = 0;
	gchar** _tmp8_;
	gint _tmp8__length1;
	GtkListBox* _tmp44_;
	GtkMenuButton* _tmp45_;
	GtkListBox* _tmp46_;
	GtkListBoxRow* _tmp47_;
	GtkStack* _tmp48_;
	const gchar* _tmp49_;
	const gchar* _tmp50_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->bus;
	_tmp1_ = ibus_bus_list_engines (_tmp0_);
	(self->priv->engines == NULL) ? NULL : (self->priv->engines = (_g_list_free__g_object_unref0_ (self->priv->engines), NULL));
	self->priv->engines = _tmp1_;
	_tmp2_ = self->priv->listbox;
	gtk_container_foreach ((GtkContainer*) _tmp2_, ___lambda57__gtk_callback, self);
	_tmp3_ = self->priv->settings;
	_tmp4_ = PANTHEON_KEYBOARD_LAYOUT_TYPE_IBUS;
	pantheon_keyboard_source_settings_reset (_tmp3_, &_tmp4_, TRUE);
	_tmp5_ = self->priv->settings;
	_tmp6_ = pantheon_keyboard_source_settings_get_active_engines (_tmp5_, &_tmp7_);
	_tmp6__length1 = _tmp7_;
	_tmp8_ = _tmp6_;
	_tmp8__length1 = _tmp6__length1;
	{
		gchar** active_engine_collection = NULL;
		gint active_engine_collection_length1 = 0;
		gint _active_engine_collection_size_ = 0;
		gint active_engine_it = 0;
		active_engine_collection = _tmp8_;
		active_engine_collection_length1 = _tmp8__length1;
		for (active_engine_it = 0; active_engine_it < active_engine_collection_length1; active_engine_it = active_engine_it + 1) {
			gchar* _tmp9_;
			gchar* active_engine = NULL;
			_tmp9_ = g_strdup (active_engine_collection[active_engine_it]);
			active_engine = _tmp9_;
			{
				GList* _tmp10_;
				_tmp10_ = self->priv->engines;
				{
					GList* engine_collection = NULL;
					GList* engine_it = NULL;
					engine_collection = _tmp10_;
					for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
						IBusEngineDesc* _tmp11_;
						IBusEngineDesc* engine = NULL;
						_tmp11_ = _g_object_ref0 ((IBusEngineDesc*) engine_it->data);
						engine = _tmp11_;
						{
							IBusEngineDesc* _tmp12_;
							const gchar* _tmp13_;
							const gchar* _tmp14_;
							const gchar* _tmp15_;
							_tmp12_ = engine;
							_tmp13_ = ibus_engine_desc_get_name (_tmp12_);
							_tmp14_ = _tmp13_;
							_tmp15_ = active_engine;
							if (g_strcmp0 (_tmp14_, _tmp15_) == 0) {
								gchar* engine_full_name = NULL;
								IBusEngineDesc* _tmp16_;
								const gchar* _tmp17_;
								const gchar* _tmp18_;
								gchar* _tmp19_;
								gchar* _tmp20_;
								IBusEngineDesc* _tmp21_;
								gchar* _tmp22_;
								gchar* _tmp23_;
								gchar* _tmp24_;
								gchar* _tmp25_;
								GtkLabel* label = NULL;
								const gchar* _tmp26_;
								GtkLabel* _tmp27_ = NULL;
								GtkListBoxRow* listboxrow = NULL;
								GtkListBoxRow* _tmp28_;
								GtkListBoxRow* _tmp29_;
								IBusEngineDesc* _tmp30_;
								const gchar* _tmp31_;
								const gchar* _tmp32_;
								gchar* _tmp33_;
								GtkListBoxRow* _tmp34_;
								GtkLabel* _tmp35_;
								GtkListBox* _tmp36_;
								GtkListBoxRow* _tmp37_;
								PantheonKeyboardSourceSettings* _tmp38_;
								IBusEngineDesc* _tmp39_;
								const gchar* _tmp40_;
								const gchar* _tmp41_;
								PantheonKeyboardInputSource* _tmp42_;
								PantheonKeyboardInputSource* _tmp43_;
								_tmp16_ = engine;
								_tmp17_ = ibus_engine_desc_get_language (_tmp16_);
								_tmp18_ = _tmp17_;
								_tmp19_ = ibus_get_language_name (_tmp18_);
								_tmp20_ = _tmp19_;
								_tmp21_ = engine;
								_tmp22_ = pantheon_keyboard_input_method_page_page_gettext_engine_longname (self, _tmp21_);
								_tmp23_ = _tmp22_;
								_tmp24_ = g_strdup_printf ("%s - %s", _tmp20_, _tmp23_);
								_tmp25_ = _tmp24_;
								_g_free0 (_tmp23_);
								_g_free0 (_tmp20_);
								engine_full_name = _tmp25_;
								_tmp26_ = engine_full_name;
								_tmp27_ = (GtkLabel*) gtk_label_new (_tmp26_);
								gtk_widget_set_halign ((GtkWidget*) _tmp27_, GTK_ALIGN_START);
								g_object_set ((GtkWidget*) _tmp27_, "margin", 6, NULL);
								g_object_ref_sink (_tmp27_);
								label = _tmp27_;
								_tmp28_ = (GtkListBoxRow*) gtk_list_box_row_new ();
								g_object_ref_sink (_tmp28_);
								listboxrow = _tmp28_;
								_tmp29_ = listboxrow;
								_tmp30_ = engine;
								_tmp31_ = ibus_engine_desc_get_name (_tmp30_);
								_tmp32_ = _tmp31_;
								_tmp33_ = g_strdup (_tmp32_);
								g_object_set_data_full ((GObject*) _tmp29_, "engine-name", _tmp33_, g_free);
								_tmp34_ = listboxrow;
								_tmp35_ = label;
								gtk_container_add ((GtkContainer*) _tmp34_, (GtkWidget*) _tmp35_);
								_tmp36_ = self->priv->listbox;
								_tmp37_ = listboxrow;
								gtk_container_add ((GtkContainer*) _tmp36_, (GtkWidget*) _tmp37_);
								_tmp38_ = self->priv->settings;
								_tmp39_ = engine;
								_tmp40_ = ibus_engine_desc_get_name (_tmp39_);
								_tmp41_ = _tmp40_;
								_tmp42_ = pantheon_keyboard_input_source_new_ibus (_tmp41_);
								_tmp43_ = _tmp42_;
								pantheon_keyboard_source_settings_add_layout (_tmp38_, _tmp43_);
								_g_object_unref0 (_tmp43_);
								_g_object_unref0 (listboxrow);
								_g_object_unref0 (label);
								_g_free0 (engine_full_name);
							}
							_g_object_unref0 (engine);
						}
					}
				}
				_g_free0 (active_engine);
			}
		}
	}
	_tmp44_ = self->priv->listbox;
	gtk_widget_show_all ((GtkWidget*) _tmp44_);
	_tmp45_ = self->priv->remove_button;
	_tmp46_ = self->priv->listbox;
	_tmp47_ = gtk_list_box_get_selected_row (_tmp46_);
	gtk_widget_set_sensitive ((GtkWidget*) _tmp45_, _tmp47_ != NULL);
	_tmp48_ = self->priv->stack;
	_tmp49_ = gtk_stack_get_visible_child_name (_tmp48_);
	_tmp50_ = _tmp49_;
	if (g_strcmp0 (_tmp50_, "main_view") == 0) {
		GtkListBox* _tmp51_;
		GList* _tmp52_;
		GList* _tmp53_;
		_tmp51_ = self->priv->listbox;
		_tmp52_ = gtk_container_get_children ((GtkContainer*) _tmp51_);
		_tmp53_ = _tmp52_;
		pantheon_keyboard_input_method_page_page_write_ibus_autostart_file (self, g_list_length (_tmp53_) > ((guint) 0));
		(_tmp53_ == NULL) ? NULL : (_tmp53_ = (g_list_free (_tmp53_), NULL));
	}
}

static gboolean
__lambda58_ (PantheonKeyboardInputMethodPagePage* self)
{
	gboolean result;
	pantheon_keyboard_input_method_page_page_set_visible_view (self, "");
	result = GDK_EVENT_PROPAGATE;
	return result;
}

static gboolean
___lambda58__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda58_ ((PantheonKeyboardInputMethodPagePage*) self);
	return result;
}

static void
pantheon_keyboard_input_method_page_page_spawn_ibus_daemon (PantheonKeyboardInputMethodPagePage* self)
{
	gboolean is_spawn_succeeded = FALSE;
	guint timeout_start_daemon = 0U;
	GtkListBox* _tmp13_;
	GList* _tmp14_;
	GList* _tmp15_;
	gboolean _tmp16_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	is_spawn_succeeded = FALSE;
	{
		gboolean _tmp0_ = FALSE;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar** _tmp3_;
		gchar** _tmp4_;
		gint _tmp4__length1;
		gchar** _tmp5_;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gint _tmp7__length1;
		gboolean _tmp8_;
		_tmp1_ = g_strdup ("ibus-daemon");
		_tmp2_ = g_strdup ("-drx");
		_tmp3_ = g_new0 (gchar*, 2 + 1);
		_tmp3_[0] = _tmp1_;
		_tmp3_[1] = _tmp2_;
		_tmp4_ = _tmp3_;
		_tmp4__length1 = 2;
		_tmp6_ = _tmp5_ = g_get_environ ();
		_tmp7_ = _tmp6_;
		_tmp7__length1 = _vala_array_length (_tmp5_);
		_tmp8_ = g_spawn_sync ("/", _tmp4_, _tmp7_, G_SPAWN_SEARCH_PATH, NULL, NULL, NULL, NULL, NULL, &_inner_error0_);
		_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
		_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
		_tmp0_ = _tmp8_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
				goto __catch0_g_spawn_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		is_spawn_succeeded = _tmp0_;
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		g_warning ("InputMethod.vala:333: %s", _tmp10_);
		_tmp11_ = e;
		_tmp12_ = _tmp11_->message;
		pantheon_keyboard_input_method_page_page_set_visible_view (self, _tmp12_);
		_g_error_free0 (e);
		return;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	timeout_start_daemon = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, ___lambda58__gsource_func, g_object_ref (self), g_object_unref);
	timeout_start_daemon = (guint) 0;
	_tmp13_ = self->priv->listbox;
	_tmp14_ = gtk_container_get_children ((GtkContainer*) _tmp13_);
	_tmp15_ = _tmp14_;
	_tmp16_ = is_spawn_succeeded & (g_list_length (_tmp15_) > ((guint) 0));
	(_tmp15_ == NULL) ? NULL : (_tmp15_ = (g_list_free (_tmp15_), NULL));
	if (_tmp16_) {
		pantheon_keyboard_input_method_page_page_write_ibus_autostart_file (self, TRUE);
	}
}

static gchar**
_vala_array_dup4 (gchar** self,
                  gssize length)
{
	if (length >= 0) {
		gchar** result;
		gssize i;
		result = g_new0 (gchar*, length + 1);
		for (i = 0; i < length; i++) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static void
pantheon_keyboard_input_method_page_page_write_ibus_autostart_file (PantheonKeyboardInputMethodPagePage* self,
                                                                    gboolean enable)
{
	gchar* config_dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* startup_dir = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar** languages = NULL;
	gchar** _tmp10_;
	gchar** _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gint languages_length1;
	gint _languages_size_;
	gchar* preferred_language = NULL;
	gchar** _tmp13_;
	gint _tmp13__length1;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	GKeyFile* keyfile = NULL;
	GKeyFile* _tmp16_;
	GKeyFile* _tmp17_;
	const gchar* _tmp18_;
	GKeyFile* _tmp19_;
	const gchar* _tmp20_;
	GKeyFile* _tmp21_;
	GKeyFile* _tmp22_;
	GKeyFile* _tmp23_;
	GKeyFile* _tmp24_;
	gchar* path = NULL;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_get_user_config_dir ();
	_tmp1_ = g_strdup (_tmp0_);
	config_dir = _tmp1_;
	_tmp2_ = config_dir;
	_tmp3_ = g_build_filename (_tmp2_, "autostart", NULL);
	startup_dir = _tmp3_;
	_tmp4_ = startup_dir;
	if (!g_file_test (_tmp4_, G_FILE_TEST_EXISTS)) {
		GFile* file = NULL;
		const gchar* _tmp5_;
		GFile* _tmp6_;
		_tmp5_ = startup_dir;
		_tmp6_ = g_file_new_for_path (_tmp5_);
		file = _tmp6_;
		{
			GFile* _tmp7_;
			_tmp7_ = file;
			g_file_make_directory_with_parents (_tmp7_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp8_;
			const gchar* _tmp9_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp8_ = e;
			_tmp9_ = _tmp8_->message;
			g_warning ("InputMethod.vala:361: %s", _tmp9_);
			_g_error_free0 (e);
			_g_object_unref0 (file);
			_g_free0 (startup_dir);
			_g_free0 (config_dir);
			return;
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (file);
			_g_free0 (startup_dir);
			_g_free0 (config_dir);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_g_object_unref0 (file);
	}
	_tmp11_ = _tmp10_ = g_get_language_names ();
	_tmp12_ = (_tmp11_ != NULL) ? _vala_array_dup4 (_tmp11_, _vala_array_length (_tmp10_)) : _tmp11_;
	_tmp12__length1 = _vala_array_length (_tmp10_);
	languages = _tmp12_;
	languages_length1 = _tmp12__length1;
	_languages_size_ = languages_length1;
	_tmp13_ = languages;
	_tmp13__length1 = languages_length1;
	_tmp14_ = _tmp13_[0];
	_tmp15_ = g_strdup (_tmp14_);
	preferred_language = _tmp15_;
	_tmp16_ = g_key_file_new ();
	keyfile = _tmp16_;
	_tmp17_ = keyfile;
	_tmp18_ = preferred_language;
	g_key_file_set_locale_string (_tmp17_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_NAME, _tmp18_, _ ("IBus Daemon"));
	_tmp19_ = keyfile;
	_tmp20_ = preferred_language;
	g_key_file_set_locale_string (_tmp19_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_COMMENT, _tmp20_, _ ("Use and manage input methods"));
	_tmp21_ = keyfile;
	g_key_file_set_string (_tmp21_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_EXEC, "ibus-daemon -drx");
	_tmp22_ = keyfile;
	g_key_file_set_string (_tmp22_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_ICON, "ibus-setup");
	_tmp23_ = keyfile;
	g_key_file_set_string (_tmp23_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_TYPE, "Application");
	_tmp24_ = keyfile;
	g_key_file_set_boolean (_tmp24_, G_KEY_FILE_DESKTOP_GROUP, "X-GNOME-Autostart-enabled", enable);
	_tmp25_ = startup_dir;
	_tmp26_ = g_build_filename (_tmp25_, "ibus-daemon.desktop", NULL);
	path = _tmp26_;
	{
		const gchar* _tmp27_;
		GKeyFile* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		_tmp27_ = path;
		_tmp28_ = keyfile;
		_tmp29_ = g_key_file_to_data (_tmp28_, NULL, NULL);
		_tmp30_ = _tmp29_;
		g_file_set_contents (_tmp27_, _tmp30_, (gssize) -1, &_inner_error0_);
		_g_free0 (_tmp30_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp31_;
		GError* _tmp32_;
		const gchar* _tmp33_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp31_ = path;
		_tmp32_ = e;
		_tmp33_ = _tmp32_->message;
		g_warning ("InputMethod.vala:387: Could not write to file %s: %s", _tmp31_, _tmp33_);
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (path);
		_g_key_file_unref0 (keyfile);
		_g_free0 (preferred_language);
		languages = (_vala_array_free (languages, languages_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (startup_dir);
		_g_free0 (config_dir);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_free0 (path);
	_g_key_file_unref0 (keyfile);
	_g_free0 (preferred_language);
	languages = (_vala_array_free (languages, languages_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (startup_dir);
	_g_free0 (config_dir);
}

static void
pantheon_keyboard_input_method_page_page_set_visible_view (PantheonKeyboardInputMethodPagePage* self,
                                                           const gchar* error_message)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (error_message != NULL);
	if (g_strcmp0 (error_message, "") != 0) {
		GtkStack* _tmp0_;
		GraniteWidgetsAlertView* _tmp1_;
		_tmp0_ = self->priv->stack;
		gtk_stack_set_visible_child_name (_tmp0_, "spawn_failed_view");
		_tmp1_ = self->priv->spawn_failed_alert;
		granite_widgets_alert_view_set_description (_tmp1_, error_message);
	} else {
		IBusBus* _tmp2_;
		_tmp2_ = self->priv->bus;
		if (ibus_bus_is_connected (_tmp2_)) {
			GtkStack* _tmp3_;
			_tmp3_ = self->priv->stack;
			gtk_stack_set_visible_child_name (_tmp3_, "main_view");
			pantheon_keyboard_input_method_page_page_update_engines_list (self);
			pantheon_keyboard_input_method_page_page_update_popover_engines_list (self);
		} else {
			GtkStack* _tmp4_;
			_tmp4_ = self->priv->stack;
			gtk_stack_set_visible_child_name (_tmp4_, "no_daemon_runnning_view");
		}
	}
}

static gchar*
pantheon_keyboard_input_method_page_page_gettext_engine_longname (PantheonKeyboardInputMethodPagePage* self,
                                                                  IBusEngineDesc* engine)
{
	gchar* name = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* textdomain = NULL;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (engine != NULL, NULL);
	_tmp0_ = ibus_engine_desc_get_name (engine);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup (_tmp1_);
	name = _tmp2_;
	_tmp3_ = name;
	if (g_str_has_prefix (_tmp3_, "xkb:")) {
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp4_ = ibus_engine_desc_get_longname (engine);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_strdup (g_dgettext ("xkeyboard-config", _tmp5_));
		result = _tmp6_;
		_g_free0 (name);
		return result;
	}
	_tmp7_ = ibus_engine_desc_get_textdomain (engine);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_strdup (_tmp8_);
	textdomain = _tmp9_;
	_tmp10_ = textdomain;
	if (g_strcmp0 (_tmp10_, "") == 0) {
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		_tmp11_ = ibus_engine_desc_get_longname (engine);
		_tmp12_ = _tmp11_;
		_tmp13_ = g_strdup (_tmp12_);
		result = _tmp13_;
		_g_free0 (textdomain);
		_g_free0 (name);
		return result;
	}
	_tmp14_ = textdomain;
	_tmp15_ = ibus_engine_desc_get_longname (engine);
	_tmp16_ = _tmp15_;
	_tmp17_ = g_strdup (g_dgettext (_tmp14_, _tmp16_));
	result = _tmp17_;
	_g_free0 (textdomain);
	_g_free0 (name);
	return result;
}

void
pantheon_keyboard_input_method_page_page_update_popover_engines_list (PantheonKeyboardInputMethodPagePage* self)
{
	IBusBus* _tmp0_;
	IBusBus* _tmp1_;
	GList* _tmp2_;
	GList* engine_lists = NULL;
	GList* _tmp3_;
	PantheonKeyboardInputMethodPageAddEnginesPopover* _tmp20_;
	GList* _tmp21_;
	g_return_if_fail (self != NULL);
	_tmp0_ = ibus_bus_new ();
	g_object_ref_sink (_tmp0_);
	_tmp1_ = _tmp0_;
	_tmp2_ = ibus_bus_list_engines (_tmp1_);
	(self->priv->engines == NULL) ? NULL : (self->priv->engines = (_g_list_free__g_object_unref0_ (self->priv->engines), NULL));
	self->priv->engines = _tmp2_;
	_g_object_unref0 (_tmp1_);
	engine_lists = NULL;
	_tmp3_ = self->priv->engines;
	{
		GList* engine_collection = NULL;
		GList* engine_it = NULL;
		engine_collection = _tmp3_;
		for (engine_it = engine_collection; engine_it != NULL; engine_it = engine_it->next) {
			IBusEngineDesc* _tmp4_;
			IBusEngineDesc* engine = NULL;
			_tmp4_ = _g_object_ref0 ((IBusEngineDesc*) engine_it->data);
			engine = _tmp4_;
			{
				gchar* full_name = NULL;
				IBusEngineDesc* _tmp5_;
				const gchar* _tmp6_;
				const gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
				IBusEngineDesc* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				IBusEngineDesc* _tmp15_;
				const gchar* _tmp16_;
				const gchar* _tmp17_;
				const gchar* _tmp18_;
				PantheonKeyboardInputMethodPageAddEnginesList* _tmp19_;
				_tmp5_ = engine;
				_tmp6_ = ibus_engine_desc_get_language (_tmp5_);
				_tmp7_ = _tmp6_;
				_tmp8_ = ibus_get_language_name (_tmp7_);
				_tmp9_ = _tmp8_;
				_tmp10_ = engine;
				_tmp11_ = pantheon_keyboard_input_method_page_page_gettext_engine_longname (self, _tmp10_);
				_tmp12_ = _tmp11_;
				_tmp13_ = g_strdup_printf ("%s - %s", _tmp9_, _tmp12_);
				_tmp14_ = _tmp13_;
				_g_free0 (_tmp12_);
				_g_free0 (_tmp9_);
				full_name = _tmp14_;
				_tmp15_ = engine;
				_tmp16_ = ibus_engine_desc_get_name (_tmp15_);
				_tmp17_ = _tmp16_;
				_tmp18_ = full_name;
				_tmp19_ = pantheon_keyboard_input_method_page_add_engines_list_new (_tmp17_, _tmp18_);
				engine_lists = g_list_append (engine_lists, _tmp19_);
				_g_free0 (full_name);
				_g_object_unref0 (engine);
			}
		}
	}
	_tmp20_ = self->priv->add_engines_popover;
	_tmp21_ = engine_lists;
	pantheon_keyboard_input_method_page_add_engines_popover_update_engines_list (_tmp20_, _tmp21_);
	(engine_lists == NULL) ? NULL : (engine_lists = (_g_list_free__g_object_unref0_ (engine_lists), NULL));
}

static void
pantheon_keyboard_input_method_page_page_update_entry_test_usable (PantheonKeyboardInputMethodPagePage* self)
{
	gboolean _tmp0_ = FALSE;
	PantheonKeyboardSourceSettings* _tmp1_;
	PantheonKeyboardInputSource* _tmp2_;
	PantheonKeyboardInputSource* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->settings;
	_tmp2_ = pantheon_keyboard_source_settings_get_active_input_source (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ != NULL) {
		PantheonKeyboardSourceSettings* _tmp4_;
		PantheonKeyboardInputSource* _tmp5_;
		PantheonKeyboardInputSource* _tmp6_;
		PantheonKeyboardLayoutType _tmp7_;
		PantheonKeyboardLayoutType _tmp8_;
		_tmp4_ = self->priv->settings;
		_tmp5_ = pantheon_keyboard_source_settings_get_active_input_source (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = pantheon_keyboard_input_source_get_layout_type (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp0_ = _tmp8_ == PANTHEON_KEYBOARD_LAYOUT_TYPE_IBUS;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkEntry* _tmp9_;
		GtkEntry* _tmp10_;
		_tmp9_ = self->priv->entry_test;
		gtk_entry_set_placeholder_text (_tmp9_, _ ("Type to test your input method"));
		_tmp10_ = self->priv->entry_test;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, TRUE);
	} else {
		GtkEntry* _tmp11_;
		GtkEntry* _tmp12_;
		_tmp11_ = self->priv->entry_test;
		gtk_entry_set_placeholder_text (_tmp11_, _ ("A keyboard layout is active"));
		_tmp12_ = self->priv->entry_test;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp12_, FALSE);
	}
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
	g_atomic_int_inc (&_data12_->_ref_count_);
	return _data12_;
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
		PantheonKeyboardInputMethodPagePage* self;
		self = _data12_->self;
		_g_free0 (_data12_->engine_name);
		_g_object_unref0 (self);
		g_slice_free (Block12Data, _data12_);
	}
}

static void
__lambda59_ (Block12Data* _data12_,
             GtkWidget* widget)
{
	PantheonKeyboardInputMethodPagePage* self;
	GtkListBoxRow* row = NULL;
	GtkListBoxRow* _tmp0_;
	gchar* row_name = NULL;
	GtkListBoxRow* _tmp1_;
	gconstpointer _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	self = _data12_->self;
	g_return_if_fail (widget != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_list_box_row_get_type (), GtkListBoxRow));
	row = _tmp0_;
	_tmp1_ = row;
	_tmp2_ = g_object_get_data ((GObject*) _tmp1_, "engine-name");
	_tmp3_ = g_strdup ((const gchar*) _tmp2_);
	row_name = _tmp3_;
	_tmp4_ = row_name;
	_tmp5_ = _data12_->engine_name;
	if (g_strcmp0 (_tmp4_, _tmp5_) == 0) {
		GtkListBox* _tmp6_;
		GtkListBoxRow* _tmp7_;
		_tmp6_ = self->priv->listbox;
		_tmp7_ = row;
		gtk_list_box_select_row (_tmp6_, _tmp7_);
	} else {
		GtkListBox* _tmp8_;
		GtkListBoxRow* _tmp9_;
		_tmp8_ = self->priv->listbox;
		_tmp9_ = row;
		gtk_list_box_unselect_row (_tmp8_, _tmp9_);
	}
	_g_free0 (row_name);
	_g_object_unref0 (row);
}

static void
___lambda59__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
	__lambda59_ (self, widget);
}

static void
pantheon_keyboard_input_method_page_page_update_list_box_selected_row (PantheonKeyboardInputMethodPagePage* self)
{
	Block12Data* _data12_;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	PantheonKeyboardSourceSettings* _tmp2_;
	PantheonKeyboardInputSource* _tmp3_;
	PantheonKeyboardInputSource* _tmp4_;
	GtkListBox* _tmp18_;
	GtkMenuButton* _tmp19_;
	GtkListBox* _tmp20_;
	GtkListBoxRow* _tmp21_;
	g_return_if_fail (self != NULL);
	_data12_ = g_slice_new0 (Block12Data);
	_data12_->_ref_count_ = 1;
	_data12_->self = g_object_ref (self);
	_tmp0_ = g_strdup ("");
	_data12_->engine_name = _tmp0_;
	_tmp2_ = self->priv->settings;
	_tmp3_ = pantheon_keyboard_source_settings_get_active_input_source (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_ != NULL) {
		PantheonKeyboardSourceSettings* _tmp5_;
		PantheonKeyboardInputSource* _tmp6_;
		PantheonKeyboardInputSource* _tmp7_;
		PantheonKeyboardLayoutType _tmp8_;
		PantheonKeyboardLayoutType _tmp9_;
		_tmp5_ = self->priv->settings;
		_tmp6_ = pantheon_keyboard_source_settings_get_active_input_source (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = pantheon_keyboard_input_source_get_layout_type (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp1_ = _tmp9_ == PANTHEON_KEYBOARD_LAYOUT_TYPE_IBUS;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		PantheonKeyboardSourceSettings* _tmp10_;
		PantheonKeyboardInputSource* _tmp11_;
		PantheonKeyboardInputSource* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		IBusBus* _tmp16_;
		const gchar* _tmp17_;
		_tmp10_ = self->priv->settings;
		_tmp11_ = pantheon_keyboard_source_settings_get_active_input_source (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = pantheon_keyboard_input_source_get_name (_tmp12_);
		_tmp14_ = _tmp13_;
		_tmp15_ = g_strdup (_tmp14_);
		_g_free0 (_data12_->engine_name);
		_data12_->engine_name = _tmp15_;
		_tmp16_ = self->priv->bus;
		_tmp17_ = _data12_->engine_name;
		ibus_bus_set_global_engine (_tmp16_, _tmp17_);
	}
	_tmp18_ = self->priv->listbox;
	gtk_container_foreach ((GtkContainer*) _tmp18_, ___lambda59__gtk_callback, _data12_);
	_tmp19_ = self->priv->remove_button;
	_tmp20_ = self->priv->listbox;
	_tmp21_ = gtk_list_box_get_selected_row (_tmp20_);
	gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, _tmp21_ != NULL);
	block12_data_unref (_data12_);
	_data12_ = NULL;
}

PantheonKeyboardInputMethodPagePage*
pantheon_keyboard_input_method_page_page_construct (GType object_type)
{
	PantheonKeyboardInputMethodPagePage * self = NULL;
	self = (PantheonKeyboardInputMethodPagePage*) g_object_new (object_type, NULL);
	return self;
}

PantheonKeyboardInputMethodPagePage*
pantheon_keyboard_input_method_page_page_new (void)
{
	return pantheon_keyboard_input_method_page_page_construct (PANTHEON_KEYBOARD_INPUT_METHOD_PAGE_TYPE_PAGE);
}

static Block13Data*
block13_data_ref (Block13Data* _data13_)
{
	g_atomic_int_inc (&_data13_->_ref_count_);
	return _data13_;
}

static void
block13_data_unref (void * _userdata_)
{
	Block13Data* _data13_;
	_data13_ = (Block13Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data13_->_ref_count_)) {
		PantheonKeyboardInputMethodPagePage* self;
		self = _data13_->self;
		_g_object_unref0 (_data13_->keyboard_shortcut_combobox);
		_g_object_unref0 (self);
		g_slice_free (Block13Data, _data13_);
	}
}

static void
_pantheon_keyboard_input_method_page_page___lambda60_ (PantheonKeyboardInputMethodPagePage* self)
{
	pantheon_keyboard_input_method_page_page_spawn_ibus_daemon (self);
}

static void
__pantheon_keyboard_input_method_page_page___lambda60__granite_widgets_alert_view_action_activated (GraniteWidgetsAlertView* _sender,
                                                                                                    gpointer self)
{
	_pantheon_keyboard_input_method_page_page___lambda60_ ((PantheonKeyboardInputMethodPagePage*) self);
}

static void
_pantheon_keyboard_input_method_page_page___lambda61_ (PantheonKeyboardInputMethodPagePage* self,
                                                       GtkListBoxRow* row)
{
	gboolean _tmp0_ = FALSE;
	if (!self->priv->selection_changing) {
		_tmp0_ = G_TYPE_CHECK_INSTANCE_TYPE (row, gtk_list_box_row_get_type ());
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar* engine_name = NULL;
		gconstpointer _tmp1_;
		gchar* _tmp2_;
		PantheonKeyboardSourceSettings* _tmp3_;
		const gchar* _tmp4_;
		IBusBus* _tmp5_;
		const gchar* _tmp6_;
		self->priv->selection_changing = TRUE;
		_tmp1_ = g_object_get_data ((GObject*) row, "engine-name");
		_tmp2_ = g_strdup ((const gchar*) _tmp1_);
		engine_name = _tmp2_;
		_tmp3_ = self->priv->settings;
		_tmp4_ = engine_name;
		pantheon_keyboard_source_settings_set_active_engine_name (_tmp3_, _tmp4_);
		_tmp5_ = self->priv->bus;
		_tmp6_ = engine_name;
		ibus_bus_set_global_engine (_tmp5_, _tmp6_);
		pantheon_keyboard_input_method_page_page_update_entry_test_usable (self);
		self->priv->selection_changing = FALSE;
		_g_free0 (engine_name);
	}
}

static void
__pantheon_keyboard_input_method_page_page___lambda61__gtk_list_box_row_selected (GtkListBox* _sender,
                                                                                  GtkListBoxRow* row,
                                                                                  gpointer self)
{
	_pantheon_keyboard_input_method_page_page___lambda61_ ((PantheonKeyboardInputMethodPagePage*) self, row);
}

static void
_pantheon_keyboard_input_method_page_page___lambda62_ (PantheonKeyboardInputMethodPagePage* self,
                                                       const gchar* name)
{
	g_return_if_fail (name != NULL);
	pantheon_keyboard_input_method_page_page_update_list_box_selected_row (self);
	pantheon_keyboard_input_method_page_page_update_entry_test_usable (self);
}

static void
__pantheon_keyboard_input_method_page_page___lambda62__ibus_bus_global_engine_changed (IBusBus* _sender,
                                                                                       const gchar* name,
                                                                                       gpointer self)
{
	_pantheon_keyboard_input_method_page_page___lambda62_ ((PantheonKeyboardInputMethodPagePage*) self, name);
}

static void
_pantheon_keyboard_input_method_page_page___lambda63_ (PantheonKeyboardInputMethodPagePage* self)
{
	PantheonKeyboardInputMethodPageAddEnginesPopover* _tmp0_;
	_tmp0_ = self->priv->add_engines_popover;
	gtk_widget_show_all ((GtkWidget*) _tmp0_);
}

static void
__pantheon_keyboard_input_method_page_page___lambda63__gtk_button_clicked (GtkButton* _sender,
                                                                           gpointer self)
{
	_pantheon_keyboard_input_method_page_page___lambda63_ ((PantheonKeyboardInputMethodPagePage*) self);
}

static void
_pantheon_keyboard_input_method_page_page___lambda64_ (PantheonKeyboardInputMethodPagePage* self,
                                                       const gchar* engine)
{
	PantheonKeyboardSourceSettings* _tmp0_;
	g_return_if_fail (engine != NULL);
	_tmp0_ = self->priv->settings;
	if (pantheon_keyboard_source_settings_add_active_engine (_tmp0_, engine)) {
		pantheon_keyboard_input_method_page_page_update_engines_list (self);
	}
}

static void
__pantheon_keyboard_input_method_page_page___lambda64__pantheon_keyboard_input_method_page_add_engines_popover_add_engine (PantheonKeyboardInputMethodPageAddEnginesPopover* _sender,
                                                                                                                           const gchar* new_engine,
                                                                                                                           gpointer self)
{
	_pantheon_keyboard_input_method_page_page___lambda64_ ((PantheonKeyboardInputMethodPagePage*) self, new_engine);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static void
_vala_gchar_free_function_content_of (gpointer data)
{
	gchar* self;
	self = *((gchar**) data);
	_g_free0_ (self);
}

static gpointer
vala_g_array_remove_index (GArray* self,
                           guint index)
{
	gpointer g = NULL;
	gpointer* _tmp0_;
	gint _tmp0__length1;
	gpointer _tmp1_;
	gpointer result;
	g_return_val_if_fail (self != NULL, NULL);
	_vala_assert (self->len > index, "length > index");
	_tmp0_ = self->data;
	_tmp0__length1 = self->len;
	_tmp1_ = _tmp0_[index];
	_tmp0_[index] = NULL;
	g = _tmp1_;
	g_array_remove_index (self, index);
	result = g;
	return result;
}

static void
_vala_array_add6 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_pantheon_keyboard_input_method_page_page___lambda65_ (PantheonKeyboardInputMethodPagePage* self)
{
	gint index = 0;
	GtkListBox* _tmp0_;
	GtkListBoxRow* _tmp1_;
	GArray* removed_lists = NULL;
	GArray* _tmp2_;
	PantheonKeyboardSourceSettings* _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gint _tmp5_ = 0;
	gchar** _tmp6_;
	gint _tmp6__length1;
	GArray* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar** new_engines = NULL;
	gint new_engines_length1 = 0;
	gint _new_engines_size_ = 0;
	PantheonKeyboardSourceSettings* _tmp20_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	PantheonKeyboardSourceSettings* _tmp22_;
	_tmp0_ = self->priv->listbox;
	_tmp1_ = gtk_list_box_get_selected_row (_tmp0_);
	index = gtk_list_box_row_get_index (_tmp1_);
	_tmp2_ = g_array_new (TRUE, TRUE, sizeof (gchar*));
	g_array_set_clear_func (_tmp2_, (GDestroyNotify) _vala_gchar_free_function_content_of);
	removed_lists = _tmp2_;
	_tmp3_ = self->priv->settings;
	_tmp4_ = pantheon_keyboard_source_settings_get_active_engines (_tmp3_, &_tmp5_);
	_tmp4__length1 = _tmp5_;
	_tmp6_ = _tmp4_;
	_tmp6__length1 = _tmp4__length1;
	{
		gchar** active_engine_collection = NULL;
		gint active_engine_collection_length1 = 0;
		gint _active_engine_collection_size_ = 0;
		gint active_engine_it = 0;
		active_engine_collection = _tmp6_;
		active_engine_collection_length1 = _tmp6__length1;
		for (active_engine_it = 0; active_engine_it < active_engine_collection_length1; active_engine_it = active_engine_it + 1) {
			gchar* _tmp7_;
			gchar* active_engine = NULL;
			_tmp7_ = g_strdup (active_engine_collection[active_engine_it]);
			active_engine = _tmp7_;
			{
				GArray* _tmp8_;
				const gchar* _tmp9_;
				gchar* _tmp10_;
				_tmp8_ = removed_lists;
				_tmp9_ = active_engine;
				_tmp10_ = g_strdup (_tmp9_);
				g_array_append_val (_tmp8_, _tmp10_);
				_g_free0 (active_engine);
			}
		}
	}
	_tmp11_ = removed_lists;
	_tmp12_ = vala_g_array_remove_index (_tmp11_, (guint) index);
	_tmp13_ = _tmp12_;
	_g_free0 (_tmp13_);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp14_ = FALSE;
			_tmp14_ = TRUE;
			while (TRUE) {
				GArray* _tmp16_;
				GArray* _tmp17_;
				const gchar* _tmp18_;
				gchar* _tmp19_;
				if (!_tmp14_) {
					gint _tmp15_;
					_tmp15_ = i;
					i = _tmp15_ + 1;
				}
				_tmp14_ = FALSE;
				_tmp16_ = removed_lists;
				if (!(((guint) i) < _tmp16_->len)) {
					break;
				}
				_tmp17_ = removed_lists;
				_tmp18_ = g_array_index (_tmp17_, gchar*, (guint) i);
				_tmp19_ = g_strdup (_tmp18_);
				_vala_array_add6 (&new_engines, &new_engines_length1, &_new_engines_size_, _tmp19_);
			}
		}
	}
	_tmp20_ = self->priv->settings;
	_tmp21_ = new_engines;
	_tmp21__length1 = new_engines_length1;
	pantheon_keyboard_source_settings_set_active_engines (_tmp20_, _tmp21_, _tmp21__length1);
	pantheon_keyboard_input_method_page_page_update_engines_list (self);
	_tmp22_ = self->priv->settings;
	pantheon_keyboard_source_settings_set_active_index (_tmp22_, (guint) 0);
	new_engines = (_vala_array_free (new_engines, new_engines_length1, (GDestroyNotify) g_free), NULL);
	_g_array_unref0 (removed_lists);
}

static void
__pantheon_keyboard_input_method_page_page___lambda65__gtk_button_clicked (GtkButton* _sender,
                                                                           gpointer self)
{
	_pantheon_keyboard_input_method_page_page___lambda65_ ((PantheonKeyboardInputMethodPagePage*) self);
}

static void
_pantheon_keyboard_input_method_page_page___lambda66_ (Block13Data* _data13_)
{
	PantheonKeyboardInputMethodPagePage* self;
	GtkComboBoxText* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	self = _data13_->self;
	_tmp0_ = _data13_->keyboard_shortcut_combobox;
	_tmp1_ = gtk_combo_box_get_active_id ((GtkComboBox*) _tmp0_);
	_tmp2_ = _tmp1_;
	pantheon_keyboard_input_method_page_page_set_keyboard_shortcut (self, _tmp2_);
}

static void
__pantheon_keyboard_input_method_page_page___lambda66__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                              gpointer self)
{
	_pantheon_keyboard_input_method_page_page___lambda66_ (self);
}

static void
_pantheon_keyboard_input_method_page_page___lambda67_ (PantheonKeyboardInputMethodPagePage* self)
{
	pantheon_keyboard_input_method_page_page_update_list_box_selected_row (self);
	pantheon_keyboard_input_method_page_page_update_entry_test_usable (self);
}

static void
__pantheon_keyboard_input_method_page_page___lambda67__g_object_notify (GObject* _sender,
                                                                        GParamSpec* pspec,
                                                                        gpointer self)
{
	_pantheon_keyboard_input_method_page_page___lambda67_ ((PantheonKeyboardInputMethodPagePage*) self);
}

static GObject *
pantheon_keyboard_input_method_page_page_constructor (GType type,
                                                      guint n_construct_properties,
                                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PantheonKeyboardInputMethodPagePage * self;
	Block13Data* _data13_;
	PantheonKeyboardSourceSettings* _tmp0_;
	IBusBus* _tmp1_;
	GSettings* _tmp2_;
	GraniteWidgetsAlertView* no_daemon_runnning_alert = NULL;
	GraniteWidgetsAlertView* _tmp3_ = NULL;
	GraniteWidgetsAlertView* _tmp4_;
	GtkStyleContext* _tmp5_;
	GraniteWidgetsAlertView* _tmp6_;
	GraniteWidgetsAlertView* _tmp7_;
	GraniteWidgetsAlertView* _tmp8_ = NULL;
	GraniteWidgetsAlertView* _tmp9_;
	GtkStyleContext* _tmp10_;
	GtkListBox* _tmp11_ = NULL;
	GtkListBox* _tmp12_;
	IBusBus* _tmp13_;
	IBusBus* _tmp14_;
	GtkScrolledWindow* scroll = NULL;
	GtkScrolledWindow* _tmp15_ = NULL;
	GtkScrolledWindow* _tmp16_;
	GtkListBox* _tmp17_;
	PantheonKeyboardInputMethodPageAddEnginesPopover* _tmp18_;
	GtkMenuButton* add_button = NULL;
	GtkImage* _tmp19_;
	PantheonKeyboardInputMethodPageAddEnginesPopover* _tmp20_;
	GtkPopover* _tmp21_;
	gchar* _tmp22_;
	GtkMenuButton* _tmp23_ = NULL;
	GtkImage* _tmp24_;
	gchar* _tmp25_;
	GtkMenuButton* _tmp26_ = NULL;
	GtkActionBar* actionbar = NULL;
	GtkActionBar* _tmp27_;
	GtkActionBar* _tmp28_;
	GtkStyleContext* _tmp29_;
	GtkActionBar* _tmp30_;
	GtkMenuButton* _tmp31_;
	GtkActionBar* _tmp32_;
	GtkMenuButton* _tmp33_;
	GtkGrid* left_grid = NULL;
	GtkGrid* _tmp34_;
	GtkGrid* _tmp35_;
	GtkScrolledWindow* _tmp36_;
	GtkGrid* _tmp37_;
	GtkActionBar* _tmp38_;
	GtkFrame* display = NULL;
	GtkFrame* _tmp39_;
	GtkFrame* _tmp40_;
	GtkGrid* _tmp41_;
	GtkLabel* keyboard_shortcut_label = NULL;
	GtkLabel* _tmp42_ = NULL;
	GtkComboBoxText* _tmp43_ = NULL;
	GtkComboBoxText* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	GtkComboBoxText* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	GtkComboBoxText* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	GtkComboBoxText* _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	GtkLabel* show_ibus_panel_label = NULL;
	GtkLabel* _tmp56_ = NULL;
	GtkComboBoxText* show_ibus_panel_combobox = NULL;
	GtkComboBoxText* _tmp57_ = NULL;
	GtkComboBoxText* _tmp58_;
	GtkComboBoxText* _tmp59_;
	GtkComboBoxText* _tmp60_;
	GtkLabel* embed_preedit_text_label = NULL;
	GtkLabel* _tmp61_ = NULL;
	GtkSwitch* embed_preedit_text_switch = NULL;
	GtkSwitch* _tmp62_ = NULL;
	GtkEntry* _tmp63_ = NULL;
	GtkGrid* right_grid = NULL;
	GtkGrid* _tmp64_ = NULL;
	GtkGrid* _tmp65_;
	GtkLabel* _tmp66_;
	GtkGrid* _tmp67_;
	GtkComboBoxText* _tmp68_;
	GtkGrid* _tmp69_;
	GtkLabel* _tmp70_;
	GtkGrid* _tmp71_;
	GtkComboBoxText* _tmp72_;
	GtkGrid* _tmp73_;
	GtkLabel* _tmp74_;
	GtkGrid* _tmp75_;
	GtkSwitch* _tmp76_;
	GtkGrid* main_grid = NULL;
	GtkGrid* _tmp77_ = NULL;
	GtkGrid* _tmp78_;
	GtkFrame* _tmp79_;
	GtkGrid* _tmp80_;
	GtkGrid* _tmp81_;
	GtkGrid* _tmp82_;
	GtkEntry* _tmp83_;
	GtkStack* _tmp84_;
	GtkStack* _tmp85_;
	GraniteWidgetsAlertView* _tmp86_;
	GtkStack* _tmp87_;
	GraniteWidgetsAlertView* _tmp88_;
	GtkStack* _tmp89_;
	GtkGrid* _tmp90_;
	GtkStack* _tmp91_;
	GtkStack* _tmp92_;
	GtkMenuButton* _tmp93_;
	PantheonKeyboardInputMethodPageAddEnginesPopover* _tmp94_;
	GtkMenuButton* _tmp95_;
	GtkComboBoxText* _tmp96_;
	GSettings* _tmp97_;
	GtkComboBoxText* _tmp98_;
	GSettings* _tmp99_;
	GtkSwitch* _tmp100_;
	PantheonKeyboardSourceSettings* _tmp101_;
	parent_class = G_OBJECT_CLASS (pantheon_keyboard_input_method_page_page_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PANTHEON_KEYBOARD_INPUT_METHOD_PAGE_TYPE_PAGE, PantheonKeyboardInputMethodPagePage);
	_data13_ = g_slice_new0 (Block13Data);
	_data13_->_ref_count_ = 1;
	_data13_->self = g_object_ref (self);
	_tmp0_ = pantheon_keyboard_source_settings_get_instance ();
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp0_;
	_tmp1_ = ibus_bus_new ();
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->bus);
	self->priv->bus = _tmp1_;
	_tmp2_ = g_settings_new ("org.freedesktop.ibus.panel");
	_g_object_unref0 (self->priv->ibus_panel_settings);
	self->priv->ibus_panel_settings = _tmp2_;
	_tmp3_ = granite_widgets_alert_view_new (_ ("IBus Daemon is not running"), _ ("You need to run the IBus daemon to enable or configure input method en" \
"gines."), "dialog-information");
	gtk_widget_set_halign ((GtkWidget*) _tmp3_, GTK_ALIGN_CENTER);
	gtk_widget_set_valign ((GtkWidget*) _tmp3_, GTK_ALIGN_CENTER);
	g_object_ref_sink (_tmp3_);
	no_daemon_runnning_alert = _tmp3_;
	_tmp4_ = no_daemon_runnning_alert;
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
	gtk_style_context_remove_class (_tmp5_, GTK_STYLE_CLASS_VIEW);
	_tmp6_ = no_daemon_runnning_alert;
	granite_widgets_alert_view_show_action (_tmp6_, _ ("Start IBus Daemon"));
	_tmp7_ = no_daemon_runnning_alert;
	g_signal_connect_object (_tmp7_, "action-activated", (GCallback) __pantheon_keyboard_input_method_page_page___lambda60__granite_widgets_alert_view_action_activated, self, 0);
	_tmp8_ = granite_widgets_alert_view_new (_ ("Could not start the IBus daemon"), "", "dialog-error");
	gtk_widget_set_halign ((GtkWidget*) _tmp8_, GTK_ALIGN_CENTER);
	gtk_widget_set_valign ((GtkWidget*) _tmp8_, GTK_ALIGN_CENTER);
	g_object_ref_sink (_tmp8_);
	_g_object_unref0 (self->priv->spawn_failed_alert);
	self->priv->spawn_failed_alert = _tmp8_;
	_tmp9_ = self->priv->spawn_failed_alert;
	_tmp10_ = gtk_widget_get_style_context ((GtkWidget*) _tmp9_);
	gtk_style_context_remove_class (_tmp10_, GTK_STYLE_CLASS_VIEW);
	_tmp11_ = (GtkListBox*) gtk_list_box_new ();
	gtk_list_box_set_selection_mode (_tmp11_, GTK_SELECTION_BROWSE);
	g_object_ref_sink (_tmp11_);
	_g_object_unref0 (self->priv->listbox);
	self->priv->listbox = _tmp11_;
	_tmp12_ = self->priv->listbox;
	g_signal_connect_object (_tmp12_, "row-selected", (GCallback) __pantheon_keyboard_input_method_page_page___lambda61__gtk_list_box_row_selected, self, 0);
	_tmp13_ = self->priv->bus;
	ibus_bus_set_watch_ibus_signal (_tmp13_, TRUE);
	_tmp14_ = self->priv->bus;
	g_signal_connect_object (_tmp14_, "global-engine-changed", (GCallback) __pantheon_keyboard_input_method_page_page___lambda62__ibus_bus_global_engine_changed, self, 0);
	_tmp15_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_set (_tmp15_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
	g_object_set ((GtkWidget*) _tmp15_, "expand", TRUE, NULL);
	g_object_ref_sink (_tmp15_);
	scroll = _tmp15_;
	_tmp16_ = scroll;
	_tmp17_ = self->priv->listbox;
	gtk_container_add ((GtkContainer*) _tmp16_, (GtkWidget*) _tmp17_);
	_tmp18_ = pantheon_keyboard_input_method_page_add_engines_popover_new ();
	g_object_ref_sink (_tmp18_);
	_g_object_unref0 (self->priv->add_engines_popover);
	self->priv->add_engines_popover = _tmp18_;
	_tmp19_ = (GtkImage*) gtk_image_new_from_icon_name ("list-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp19_);
	_tmp20_ = self->priv->add_engines_popover;
	_tmp21_ = _g_object_ref0 ((GtkPopover*) _tmp20_);
	_tmp22_ = g_strdup (_ ("Add…"));
	_tmp23_ = (GtkMenuButton*) gtk_menu_button_new ();
	gtk_button_set_image ((GtkButton*) _tmp23_, (GtkWidget*) _tmp19_);
	_g_object_unref0 (_tmp19_);
	gtk_menu_button_set_popover (_tmp23_, _tmp21_);
	_g_object_unref0 (_tmp21_);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp23_, _tmp22_);
	_g_free0 (_tmp22_);
	g_object_ref_sink (_tmp23_);
	add_button = _tmp23_;
	_tmp24_ = (GtkImage*) gtk_image_new_from_icon_name ("list-remove-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp24_);
	_tmp25_ = g_strdup (_ ("Remove"));
	_tmp26_ = (GtkMenuButton*) gtk_menu_button_new ();
	gtk_button_set_image ((GtkButton*) _tmp26_, (GtkWidget*) _tmp24_);
	_g_object_unref0 (_tmp24_);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp26_, _tmp25_);
	_g_free0 (_tmp25_);
	g_object_ref_sink (_tmp26_);
	_g_object_unref0 (self->priv->remove_button);
	self->priv->remove_button = _tmp26_;
	_tmp27_ = (GtkActionBar*) gtk_action_bar_new ();
	g_object_ref_sink (_tmp27_);
	actionbar = _tmp27_;
	_tmp28_ = actionbar;
	_tmp29_ = gtk_widget_get_style_context ((GtkWidget*) _tmp28_);
	gtk_style_context_add_class (_tmp29_, GTK_STYLE_CLASS_INLINE_TOOLBAR);
	_tmp30_ = actionbar;
	_tmp31_ = add_button;
	gtk_container_add ((GtkContainer*) _tmp30_, (GtkWidget*) _tmp31_);
	_tmp32_ = actionbar;
	_tmp33_ = self->priv->remove_button;
	gtk_container_add ((GtkContainer*) _tmp32_, (GtkWidget*) _tmp33_);
	_tmp34_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp34_);
	left_grid = _tmp34_;
	_tmp35_ = left_grid;
	_tmp36_ = scroll;
	gtk_grid_attach (_tmp35_, (GtkWidget*) _tmp36_, 0, 0, 1, 1);
	_tmp37_ = left_grid;
	_tmp38_ = actionbar;
	gtk_grid_attach (_tmp37_, (GtkWidget*) _tmp38_, 0, 1, 1, 1);
	_tmp39_ = (GtkFrame*) gtk_frame_new (NULL);
	g_object_ref_sink (_tmp39_);
	display = _tmp39_;
	_tmp40_ = display;
	_tmp41_ = left_grid;
	gtk_container_add ((GtkContainer*) _tmp40_, (GtkWidget*) _tmp41_);
	_tmp42_ = (GtkLabel*) gtk_label_new (_ ("Switch engines:"));
	gtk_widget_set_halign ((GtkWidget*) _tmp42_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp42_);
	keyboard_shortcut_label = _tmp42_;
	_tmp43_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	gtk_widget_set_halign ((GtkWidget*) _tmp43_, GTK_ALIGN_START);
	g_object_ref_sink (_tmp43_);
	_data13_->keyboard_shortcut_combobox = _tmp43_;
	_tmp44_ = _data13_->keyboard_shortcut_combobox;
	_tmp45_ = granite_accel_to_string ("<Alt>space");
	_tmp46_ = _tmp45_;
	gtk_combo_box_text_append (_tmp44_, "alt-space", _tmp46_);
	_g_free0 (_tmp46_);
	_tmp47_ = _data13_->keyboard_shortcut_combobox;
	_tmp48_ = granite_accel_to_string ("<Control>space");
	_tmp49_ = _tmp48_;
	gtk_combo_box_text_append (_tmp47_, "ctl-space", _tmp49_);
	_g_free0 (_tmp49_);
	_tmp50_ = _data13_->keyboard_shortcut_combobox;
	_tmp51_ = granite_accel_to_string ("<Shift>space");
	_tmp52_ = _tmp51_;
	gtk_combo_box_text_append (_tmp50_, "shift-space", _tmp52_);
	_g_free0 (_tmp52_);
	_tmp53_ = _data13_->keyboard_shortcut_combobox;
	_tmp54_ = pantheon_keyboard_input_method_page_page_get_keyboard_shortcut (self);
	_tmp55_ = _tmp54_;
	gtk_combo_box_set_active_id ((GtkComboBox*) _tmp53_, _tmp55_);
	_g_free0 (_tmp55_);
	_tmp56_ = (GtkLabel*) gtk_label_new (_ ("Show property panel:"));
	gtk_widget_set_halign ((GtkWidget*) _tmp56_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp56_);
	show_ibus_panel_label = _tmp56_;
	_tmp57_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	gtk_widget_set_halign ((GtkWidget*) _tmp57_, GTK_ALIGN_START);
	g_object_ref_sink (_tmp57_);
	show_ibus_panel_combobox = _tmp57_;
	_tmp58_ = show_ibus_panel_combobox;
	gtk_combo_box_text_append (_tmp58_, "none", _ ("Do not show"));
	_tmp59_ = show_ibus_panel_combobox;
	gtk_combo_box_text_append (_tmp59_, "auto-hide", _ ("Auto hide"));
	_tmp60_ = show_ibus_panel_combobox;
	gtk_combo_box_text_append (_tmp60_, "always-show", _ ("Always show"));
	_tmp61_ = (GtkLabel*) gtk_label_new (_ ("Embed preedit text in application window:"));
	gtk_widget_set_halign ((GtkWidget*) _tmp61_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp61_);
	embed_preedit_text_label = _tmp61_;
	_tmp62_ = (GtkSwitch*) gtk_switch_new ();
	gtk_widget_set_halign ((GtkWidget*) _tmp62_, GTK_ALIGN_START);
	g_object_ref_sink (_tmp62_);
	embed_preedit_text_switch = _tmp62_;
	_tmp63_ = (GtkEntry*) gtk_entry_new ();
	gtk_widget_set_hexpand ((GtkWidget*) _tmp63_, TRUE);
	gtk_widget_set_valign ((GtkWidget*) _tmp63_, GTK_ALIGN_END);
	g_object_ref_sink (_tmp63_);
	_g_object_unref0 (self->priv->entry_test);
	self->priv->entry_test = _tmp63_;
	pantheon_keyboard_input_method_page_page_update_entry_test_usable (self);
	_tmp64_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp64_, 12);
	gtk_widget_set_halign ((GtkWidget*) _tmp64_, GTK_ALIGN_CENTER);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp64_, TRUE);
	g_object_set ((GtkWidget*) _tmp64_, "margin", 12, NULL);
	gtk_grid_set_row_spacing (_tmp64_, 12);
	g_object_ref_sink (_tmp64_);
	right_grid = _tmp64_;
	_tmp65_ = right_grid;
	_tmp66_ = keyboard_shortcut_label;
	gtk_grid_attach (_tmp65_, (GtkWidget*) _tmp66_, 0, 0, 1, 1);
	_tmp67_ = right_grid;
	_tmp68_ = _data13_->keyboard_shortcut_combobox;
	gtk_grid_attach (_tmp67_, (GtkWidget*) _tmp68_, 1, 0, 1, 1);
	_tmp69_ = right_grid;
	_tmp70_ = show_ibus_panel_label;
	gtk_grid_attach (_tmp69_, (GtkWidget*) _tmp70_, 0, 1, 1, 1);
	_tmp71_ = right_grid;
	_tmp72_ = show_ibus_panel_combobox;
	gtk_grid_attach (_tmp71_, (GtkWidget*) _tmp72_, 1, 1, 1, 1);
	_tmp73_ = right_grid;
	_tmp74_ = embed_preedit_text_label;
	gtk_grid_attach (_tmp73_, (GtkWidget*) _tmp74_, 0, 2, 1, 1);
	_tmp75_ = right_grid;
	_tmp76_ = embed_preedit_text_switch;
	gtk_grid_attach (_tmp75_, (GtkWidget*) _tmp76_, 1, 2, 1, 1);
	_tmp77_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp77_, 12);
	gtk_grid_set_row_spacing (_tmp77_, 12);
	g_object_ref_sink (_tmp77_);
	main_grid = _tmp77_;
	_tmp78_ = main_grid;
	_tmp79_ = display;
	gtk_grid_attach (_tmp78_, (GtkWidget*) _tmp79_, 0, 0, 1, 2);
	_tmp80_ = main_grid;
	_tmp81_ = right_grid;
	gtk_grid_attach (_tmp80_, (GtkWidget*) _tmp81_, 1, 0, 1, 1);
	_tmp82_ = main_grid;
	_tmp83_ = self->priv->entry_test;
	gtk_grid_attach (_tmp82_, (GtkWidget*) _tmp83_, 1, 1, 1, 1);
	_tmp84_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp84_);
	_g_object_unref0 (self->priv->stack);
	self->priv->stack = _tmp84_;
	_tmp85_ = self->priv->stack;
	_tmp86_ = no_daemon_runnning_alert;
	gtk_stack_add_named (_tmp85_, (GtkWidget*) _tmp86_, "no_daemon_runnning_view");
	_tmp87_ = self->priv->stack;
	_tmp88_ = self->priv->spawn_failed_alert;
	gtk_stack_add_named (_tmp87_, (GtkWidget*) _tmp88_, "spawn_failed_view");
	_tmp89_ = self->priv->stack;
	_tmp90_ = main_grid;
	gtk_stack_add_named (_tmp89_, (GtkWidget*) _tmp90_, "main_view");
	_tmp91_ = self->priv->stack;
	gtk_widget_show_all ((GtkWidget*) _tmp91_);
	_tmp92_ = self->priv->stack;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp92_);
	pantheon_keyboard_input_method_page_page_set_visible_view (self, "");
	_tmp93_ = add_button;
	g_signal_connect_object ((GtkButton*) _tmp93_, "clicked", (GCallback) __pantheon_keyboard_input_method_page_page___lambda63__gtk_button_clicked, self, 0);
	_tmp94_ = self->priv->add_engines_popover;
	g_signal_connect_object (_tmp94_, "add-engine", (GCallback) __pantheon_keyboard_input_method_page_page___lambda64__pantheon_keyboard_input_method_page_add_engines_popover_add_engine, self, 0);
	_tmp95_ = self->priv->remove_button;
	g_signal_connect_object ((GtkButton*) _tmp95_, "clicked", (GCallback) __pantheon_keyboard_input_method_page_page___lambda65__gtk_button_clicked, self, 0);
	_tmp96_ = _data13_->keyboard_shortcut_combobox;
	g_signal_connect_data ((GtkComboBox*) _tmp96_, "changed", (GCallback) __pantheon_keyboard_input_method_page_page___lambda66__gtk_combo_box_changed, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
	_tmp97_ = self->priv->ibus_panel_settings;
	_tmp98_ = show_ibus_panel_combobox;
	g_settings_bind (_tmp97_, "show", (GObject*) _tmp98_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp99_ = pantheon_keyboard_plug_ibus_general_settings;
	_tmp100_ = embed_preedit_text_switch;
	g_settings_bind (_tmp99_, "embed-preedit-text", (GObject*) _tmp100_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp101_ = self->priv->settings;
	g_signal_connect_object ((GObject*) _tmp101_, "notify::active-index", (GCallback) __pantheon_keyboard_input_method_page_page___lambda67__g_object_notify, self, 0);
	pantheon_keyboard_input_method_page_page_update_list_box_selected_row (self);
	_g_object_unref0 (main_grid);
	_g_object_unref0 (right_grid);
	_g_object_unref0 (embed_preedit_text_switch);
	_g_object_unref0 (embed_preedit_text_label);
	_g_object_unref0 (show_ibus_panel_combobox);
	_g_object_unref0 (show_ibus_panel_label);
	_g_object_unref0 (keyboard_shortcut_label);
	_g_object_unref0 (display);
	_g_object_unref0 (left_grid);
	_g_object_unref0 (actionbar);
	_g_object_unref0 (add_button);
	_g_object_unref0 (scroll);
	_g_object_unref0 (no_daemon_runnning_alert);
	block13_data_unref (_data13_);
	_data13_ = NULL;
	return obj;
}

static void
pantheon_keyboard_input_method_page_page_class_init (PantheonKeyboardInputMethodPagePageClass * klass,
                                                     gpointer klass_data)
{
	pantheon_keyboard_input_method_page_page_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PantheonKeyboardInputMethodPagePage_private_offset);
	G_OBJECT_CLASS (klass)->constructor = pantheon_keyboard_input_method_page_page_constructor;
	G_OBJECT_CLASS (klass)->finalize = pantheon_keyboard_input_method_page_page_finalize;
}

static void
pantheon_keyboard_input_method_page_page_instance_init (PantheonKeyboardInputMethodPagePage * self,
                                                        gpointer klass)
{
	self->priv = pantheon_keyboard_input_method_page_page_get_instance_private (self);
	self->priv->selection_changing = FALSE;
}

static void
pantheon_keyboard_input_method_page_page_finalize (GObject * obj)
{
	PantheonKeyboardInputMethodPagePage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PANTHEON_KEYBOARD_INPUT_METHOD_PAGE_TYPE_PAGE, PantheonKeyboardInputMethodPagePage);
	_g_object_unref0 (self->priv->bus);
	_g_object_unref0 (self->priv->ibus_panel_settings);
	(self->priv->engines == NULL) ? NULL : (self->priv->engines = (_g_list_free__g_object_unref0_ (self->priv->engines), NULL));
	_g_object_unref0 (self->priv->spawn_failed_alert);
	_g_object_unref0 (self->priv->listbox);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->remove_button);
	_g_object_unref0 (self->priv->add_engines_popover);
	_g_object_unref0 (self->priv->stack);
	_g_object_unref0 (self->priv->entry_test);
	G_OBJECT_CLASS (pantheon_keyboard_input_method_page_page_parent_class)->finalize (obj);
}

static GType
pantheon_keyboard_input_method_page_page_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PantheonKeyboardInputMethodPagePageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pantheon_keyboard_input_method_page_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PantheonKeyboardInputMethodPagePage), 0, (GInstanceInitFunc) pantheon_keyboard_input_method_page_page_instance_init, NULL };
	GType pantheon_keyboard_input_method_page_page_type_id;
	pantheon_keyboard_input_method_page_page_type_id = g_type_register_static (gtk_grid_get_type (), "PantheonKeyboardInputMethodPagePage", &g_define_type_info, 0);
	PantheonKeyboardInputMethodPagePage_private_offset = g_type_add_instance_private (pantheon_keyboard_input_method_page_page_type_id, sizeof (PantheonKeyboardInputMethodPagePagePrivate));
	return pantheon_keyboard_input_method_page_page_type_id;
}

GType
pantheon_keyboard_input_method_page_page_get_type (void)
{
	static volatile gsize pantheon_keyboard_input_method_page_page_type_id__once = 0;
	if (g_once_init_enter (&pantheon_keyboard_input_method_page_page_type_id__once)) {
		GType pantheon_keyboard_input_method_page_page_type_id;
		pantheon_keyboard_input_method_page_page_type_id = pantheon_keyboard_input_method_page_page_get_type_once ();
		g_once_init_leave (&pantheon_keyboard_input_method_page_page_type_id__once, pantheon_keyboard_input_method_page_page_type_id);
	}
	return pantheon_keyboard_input_method_page_page_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

